// libs/core/src/utils/directives/forward-attributes.ts
import { Directive, PartType, directive } from "lit/directive.js";
import { nothing } from "lit/html.js";
var ForwardAttributesDirective = class extends Directive {
  constructor(partInfo) {
    super(partInfo);
    if (partInfo.type !== PartType.ELEMENT) {
      throw new Error(
        "The `forwardAttributes` directive must be used in element bindings"
      );
    }
  }
  render(_filter) {
    return nothing;
  }
  update(part, [filter]) {
    var _a;
    const element = part.element;
    const host = (_a = part.options) == null ? void 0 : _a.host;
    Array.from(host.attributes).forEach((attr) => {
      if (filter(attr)) {
        element.setAttribute(attr.name.replace("gds-", ""), attr.value);
      }
    });
  }
};
var forwardAttributes = directive(ForwardAttributesDirective);

export {
  forwardAttributes
};
